=== debian/changelog ===
freeorion (0.4.4-2+deb8u1) jessie; urgency=medium

  * Add fix-FTBFS.patch, fix compiler errors so that FreeOrion can be built
    from source again. (Closes: #783839)

 -- Markus Koschany <apo@gambaru.de>  Thu, 07 May 2015 13:15:29 +0200

freeorion (0.4.4-2) unstable; urgency=medium

  * Switch build-dependency from libjpeg8-dev to libjpeg-dev due to the
    libjpeg-turbo transition.
    Thanks to Ondřej Surý for the report and patch. (Closes: #763471)
  * Update debian/watch. Detect RC and normal releases.
  * Declare compliance with Debian Policy 3.9.6.

 -- Markus Koschany <apo@gambaru.de>  Tue, 30 Sep 2014 20:43:21 +0200

freeorion (0.4.4-1) unstable; urgency=medium

  * New upstream release 0.4.4 r7640.
  * Remove mips and mipsel from Architecture field.
    Although FreeOrion should be able to compile on mips and mipsel, it
    regularly FTBFS due to the lack of virtual memory on the buildd. Requests
    for help remained unanswered on debian-mips. As long as the situation does
    not change these architectures won't be supported anymore.
  * debian/rules: Delete DEB_HOST_MULTIARCH and DEB_HOST_GNU_TYPE variable.
  * Update FreeOrion man page for version 0.4.4.

 -- Markus Koschany <apo@gambaru.de>  Thu, 04 Sep 2014 19:47:41 +0200

freeorion (0.4.4~svn7616-1) unstable; urgency=medium

  * New upstream release candidate 0.4.4 RC3 r7616.
  * Update version string when creating the original source tarball and drop
    version-string.patch.
  * debian/rules: Use Tabs consistently.
  * Drop ConditionParser2.patch. Merged with release-0.4.4 branch.

 -- Markus Koschany <apo@gambaru.de>  Mon, 25 Aug 2014 15:51:58 +0200

freeorion (0.4.4~svn7504-1) unstable; urgency=medium

  * New upstream release candidate 0.4.4 RC2.
  * Update version-string.patch and REV variable in debian/rules to 7504.
  * Add ConditionParser2.patch cherry-picked from upstream trunk r7533:
    - Break enqueued condition parser into 4 sub-parsers to hopefully help
      compile by reducing memory usage on mips and mipsel.

 -- Markus Koschany <apo@gambaru.de>  Thu, 21 Aug 2014 12:43:54 +0200

freeorion (0.4.4~svn7431-1) unstable; urgency=medium

  * Upload to unstable.
  * New upstream release candidate 0.4.4 RC1.
  * debian/control: Remove spurious virtual b-d on libsdl-dev.
  * Update get-orig-source target for 0.4.4 RC1.
  * Update version string patch to version 7431.

 -- Markus Koschany <apo@gambaru.de>  Mon, 11 Aug 2014 21:59:17 +0200

freeorion (0.4.3+svn7394-1) experimental; urgency=medium

  * New upstream snapshot.
  * freeorion-data.links: Adjust the path to DejaVu fonts and point to the new
    fonts-dejavu package.
  * Update get-orig-source target.
    - Do not remove FindBullet.cmake anymore since it has been removed upstream.
  * Build with MinSizeRel and max-parallel=1 on armel, armhf, mips and mipsel
    again. Readd WEAK_HOSTS and -DCMAKE_BUILD_TYPE options. Apparently Debian's
    buildd are currently not able to cope with FreeOrion's default compiler
    options on a regular basis.
  * Update version string patch to version 7394.
  * Add Forwarded header to GG-verbose-makefile.patch.

 -- Markus Koschany <apo@gambaru.de>  Wed, 06 Aug 2014 22:31:55 +0200
