=== debian/rules ===
#!/usr/bin/make -f
#export DH_VERBOSE=1
export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed
DEB_HOST_ARCH ?= $(shell dpkg-architecture -qDEB_HOST_ARCH)
PKD  = $(abspath $(dir $(MAKEFILE_LIST)))
VER := $(shell dpkg-parsechangelog -l$(PKD)/changelog -SVersion | cut -d- -f1)
WEAK_HOSTS := armel armhf
UURL := http://svn.code.sf.net/p/freeorion/code/branches/release-0.4.4
PKG := freeorion
REV := 7640

ifneq (,$(findstring $(DEB_HOST_ARCH),$(WEAK_HOSTS)))
	MAX  := 1
	TYPE := MinSizeRel
else
	MAX  := 4
	TYPE := RelWithDebInfo
endif

%:
	dh $@ --parallel --max-parallel=$(MAX) --sourcedirectory=FreeOrion --with python2

override_dh_auto_configure:
	dh_auto_configure -- \
		-DBUILD_DOCUMENTATION=off \
		-DBUILD_TUTORIALS=off \
		-DBUILD_OGRE_DRIVER=ON \
		-DBUILD_OGRE_OIS_PLUGIN=ON \
		-DLIB_SUFFIX=/freeorion \
		-DCMAKE_VERBOSE_MAKEFILE=ON \
		-DCMAKE_BUILD_TYPE=$(TYPE)

override_dh_auto_build-indep:
	## generate 32x32 xpm icon for compatibility reasons
	convert -monitor FreeOrion/default/data/art/icons/FO_Icon_32x32.png debian/freeorion.xpm

#workaround for 'dpkg-shlibdeps: error: couldn't find library libGiGi*.so'
override_dh_shlibdeps:
	LD_LIBRARY_PATH="$(CURDIR)/debian/tmp/usr/lib/freeorion/freeorion:$(LD_LIBRARY_PATH)" dh_shlibdeps

override_dh_installchangelogs:
	dh_installchangelogs FreeOrion/changelog.txt

override_dh_install:
	dh_install --fail-missing
	find debian -type d -empty -delete -printf 'removed %p\n'
	$(RM) -v debian/freeorion-data/usr/share/games/freeorion/default/LICENSE* \
                 debian/freeorion-data/usr/share/games/freeorion/default/COPYING

override_dh_python2:
	dh_python2 -pfreeorion-data /usr/share/games

## get-orig-source
## https://wiki.debian.org/onlyjob/get-orig-source

get-orig-source: $(PKG)_$(VER).orig.tar.xz
	@

$(PKG)_$(VER).orig.tar.xz:
	svn checkout --config-option config:miscellany:use-commit-times=yes -r $(REV) \
		$(UURL) $(PKG)-$(VER) \
		|| $(RM) -r $(PKG)-$(VER)
	@echo "Clean-up..."
	cd $(PKG)-$(VER) \
		&& find . -depth -name ".svn" -exec $(RM) -r '{}' \; \
		&& $(RM) -r -v \
			FreeOrion/GG/libltdl \
			FreeOrion/loki_setup \
			FreeOrion/linux-static \
			FreeOrion/OIS \
			FreeOrion/client/human/OgrePlugins \
			FreeOrion/msvc2010 \
			FreeOrion/Xcode \
			FreeOrion/Installer \
			FreeOrion/default/*.ttf \
		&& sed -i 's:FreeOrion_WC_REVISION ???:FreeOrion_WC_REVISION $(REV):' FreeOrion/CMakeLists.txt
	@echo "Packing..."
	find -L "$(PKG)-$(VER)" -xdev -type f -print \
		| sort | XZ_OPT="-7v" tar -caf "$(PKG)_$(VER).orig.tar.xz" -T- --owner=root --group=root --mode=a+rX \
		&& $(RM) -r "$(PKG)-$(VER)"
